#include <algorithm>
#include <vector>
#include <set>
#include <cctype>
#include <cstdio>

#define MAXROW (4000)
#define MAXCOL (4000)
#define MAXNUM (256)

using std::vector; using std::set; using std::pair; using std::make_pair; using std::sort; using std::fill;

typedef unsigned long ulong; typedef unsigned char uchar; typedef pair<ulong, uchar> event;

vector<ulong> MINR(MAXNUM, MAXROW), MAXR(MAXNUM, 0), MINC(MAXNUM, MAXCOL), MAXC(MAXNUM, 0);
vector<event> INDR[2] = { vector<event> (MAXNUM), vector<event> (MAXNUM) };
set<event>    SETC[2];
static uchar  DATA[MAXROW][MAXCOL], LINE[MAXCOL + 2];
vector<uchar> MARK(MAXNUM, false);
set<uchar>    RECT[MAXNUM];

bool DFS(int cur) {
	if (MARK[cur] == 1) return false;
	if (MARK[cur]) return true;
	MARK[cur] = 1;
	for (auto it = RECT[cur].begin(); it != RECT[cur].end(); ++ it) if (!DFS(*it)) return false;
	MARK[cur] = 2;
	return true;
}

int main() {
	char *str; bool ans; ulong num, ir, ic, r1, r2, c1, c2; uchar c;
	//Считываем исходное изображение + вычисляем ожидаемые границы прямоугольников:
	FILE *fid = fopen("input.txt", "rt");
	for (ir = 0; (str = fgets((char *) LINE, MAXCOL + 2, fid)) != NULL; ++ ir) {
		for (ic = 0; (c = *(str ++)) != '\0'; ++ ic) {
			if (!isspace(c)) {
				if (MINR[c] > ir) MINR[c] = ir;
				if (MAXR[c] < ir) MAXR[c] = ir;
				if (MINC[c] > ic) MINC[c] = ic;
				if (MAXC[c] < ic) MAXC[c] = ic;
				MARK[c] = true;
			}
			if (c == '\n') break;
			DATA[ir][ic] = c;
		}
	}
	fclose(fid);
	//Формируем прямоугольную сетку:
	for (num = ir = 0; ir < MAXNUM; ++ ir) {
		if (MARK[ir]) {
			INDR[0][num] = make_pair(MINR[ir], (uchar) ir);
			INDR[1][num] = make_pair(MAXR[ir], (uchar) ir);
			++ num;
		}
	}
	INDR[0].resize(num);
	sort(INDR[0].begin(), INDR[0].end());
	INDR[1].resize(num);
	sort(INDR[1].begin(), INDR[1].end());
	//Обходим ячейки сетки:
	auto ir1 = INDR[0].begin();
	auto ir2 = INDR[1].begin();
	r1 = ir1->first;
	ans = true;
	while (ans) {
		//Открываем новые прямоугольники:
		while ((ir1 != INDR[0].end()) && (ir1->first == r1)) {
			ir = (ir1 ++)->second;
			SETC[0].insert(make_pair(MINC[ir], (uchar) ir));
			SETC[1].insert(make_pair(MAXC[ir], (uchar) ir));
		}
		if ((ir1 != INDR[0].end()) && (ir1->first <= ir2->first))
			r2 = ir1->first - 1;
		else {
			r2 = ir2->first;
		}
		auto ic1 = SETC[0].begin();
		auto ic2 = SETC[1].begin();
		c1 = ic1->first;
		set<uchar> TEMP;
		while (ans) {
			//Добавляем доступные прямоугольники в текущее множество:
			while ((ic1 != SETC[0].end()) && (ic1->first == c1)) {
				TEMP.insert((ic1 ++)->second);
			}
			if ((ic1 != SETC[0].end()) && (ic1->first <= ic2->first))
				c2 = ic1->first - 1;
			else {
				c2 = ic2->first;
			}
			//Проверяем текущую ячейку на наличие разных цветов:
			for (c = DATA[r1][c1], ir = r1; ans && (ir <= r2); ++ ir)
			for (ic = c1; ans && (ic <= c2); ++ ic) {
				ans = ans && (DATA[ir][ic] == c);
			}
			//Проверяем отношения доминирования:
			for (auto it = TEMP.begin(); it != TEMP.end(); ++ it) {
				if (c == *it) continue;
				if (RECT[*it].count(c)) { ans = false; break; }
				RECT[c].insert(*it);
			}
			//Удаляем прямоугольники:
			while ((ic2 != SETC[1].end()) && (ic2->first == c2)) {
				TEMP.erase((ic2 ++)->second);
			}
			if (ic2 == SETC[1].end()) break;
			c1 = c2 + 1;
		}
		//Закрываем прямоугольники:
		while ((ir2 != INDR[1].end()) && (ir2->first == r2)) {
			ir = (ir2 ++)->second;
			SETC[0].erase(make_pair(MINC[ir], (uchar) ir));
			SETC[1].erase(make_pair(MAXC[ir], (uchar) ir));
		}
		if (ir2 == INDR[1].end()) break;
		r1 = r2 + 1;
	}
	//Проверяем транзитивность:
	fill(MARK.begin(), MARK.end(), 0);
	for (ir = 0; ans && (ir < MAXNUM); ++ ir) {
		if (!DFS(ir)) ans = false;
	}
	//...
	fid = fopen("output.txt", "wt");
	fprintf(fid, "%i", ans? 1: 0);
	fclose(fid);
	//...
	return 0;
}
