#include <functional>
#include <sstream>
#include <vector>
#include <algorithm>
#include <cstring>
#include <cstdlib>
#include <iostream>
#include <string>
#include <cassert>
#include <ctime>
#include <map>
#include <math.h>
#include <cstdio>
#include <set>
#include <deque>
#include <memory.h>
#include <queue>

#pragma comment(linker, "/STACK:64000000")
typedef long long ll;

using namespace std;

const int MAXN = 1 << 12;
const int INF = 1e9;

char buf[MAXN];

int main() {
	freopen("input.txt", "r", stdin);
#ifndef _MSC_VER
	freopen("output.txt", "w", stdout);
#endif

	string ss;
	vector<string> a;
	char c;
	while (1) {
		if (!fgets(buf, MAXN, stdin)) break;
		a.push_back(buf);
	}
	int n = a.size();
	int m = a[0].size();

	vector<int> mnx(256, INF), mxx(256, -INF), mny(256, INF), mxy(256, -INF);
	vector<vector<vector<int> > > b(256, vector<vector<int> >(n));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			b[a[i][j]][i].push_back(j);
			mnx[a[i][j]] = min(mnx[a[i][j]], i);
			mxx[a[i][j]] = max(mxx[a[i][j]], i);
			mny[a[i][j]] = min(mny[a[i][j]], j);
			mxy[a[i][j]] = max(mxy[a[i][j]], j);
		}
	}
	for (int i = 0; i < 256; i++) for (int j = 0; j < n; j++) b[i][j].push_back(m);
	vector<int> vv;
	for (int i = 0; i < 256; i++) if (mnx[i] <= mxx[i]) vv.push_back(i);

	vector<vector<int> > e(256, vector<int>(256));
	for (int j = 0; j < 256; j++) e[32][j] = 1;

	for (int i : vv) {
		for (int j : vv) {
			if (mxx[i] < mnx[j] || mxx[j] < mnx[i]) continue;
			if (mxy[i] < mny[j] || mxy[j] < mny[i]) continue;
			for (int x = max(mnx[j], mnx[i]); x <= min(mxx[i], mxx[j]) && !e[i][j]; x++) {
				e[i][j] |= *lower_bound(b[j][x].begin(), b[j][x].end(), mny[i]) <= mxy[i];
			}
		}
	}

	vector<int> vis(256);
	vector<int> vct;
	function<void(int)> dfs = [&](int v) {
		vis[v] = 1;
		for (int u : vv) {
			if (e[v][u] && !vis[u]) {
				dfs(u);
			}
		}
		vct.push_back(v);
	};
	for (int x : vv) {
		if (!vis[x]) {
			dfs(x);
		}
	}
	reverse(vct.begin(), vct.end());
	vector<int> ovct(256);
	for (int i = 0; i < (int)vv.size(); i++) ovct[vct[i]] = i;

	bool ok = 1;
	for (int u : vv) {
		for (int v : vv) {
			if (e[u][v]) {
				ok &= ovct[u] <= ovct[v];
			}
		}
	}
	cout << (int)(ok) << endl;

	return 0;
}
